#include <QuickTime/QuickTime.h>
#include <ApplicationServices/ApplicationServices.h>
#include <stdio.h>

#include "WSDY1.h"

OSStatus ExportCGImageToPNGFile(CGImageRef inImageRef, CFStringRef inPath);

int main(int argc, const char * argv[]) 
{
	// Unlock to remove demo restrictions
	
	WSDY1unlock("LXXXXX-XXXXX","WSDY1-XXXX-XXXXXXXX");

	// Set data and moduleWidth / -Height

	WSDY1setDataToEncode("12345678");
	WSDY1setModuleWidth(1.0f);
	WSDY1setModuleHeight(30.0f);
	
	// Create barcode with 300 dpi
	
	CGImageRef img = WSDY1createCode(300);
	
	// Save as PNG
	
	ExportCGImageToPNGFile(img, CFSTR("/tmp/sample-barcode.png"));	
	
    return 0;
}

// c.f. http://developer.apple.com/technotes/tn2005/tn2140.html

// include	<ApplicationServices/ApplicationServices.h>
//			<QuickTime/QuickTime.h>  
//
// link		QuickTime.framework
//			ApplicationServices.framework

OSStatus ExportCGImageToPNGFile(CGImageRef inImageRef, CFStringRef inPath)
{
    Handle  dataRef = NULL;
    OSType  dataRefType;

    GraphicsExportComponent grex = 0;
    unsigned long sizeWritten;

    ComponentResult result;

    // create the data reference
    result = QTNewDataReferenceFromFullPathCFString(inPath, kQTNativeDefaultPathStyle,
                                                    0, &dataRef, &dataRefType);

    if (NULL != dataRef && noErr == result) {
        // get the PNG exporter
        result = OpenADefaultComponent(GraphicsExporterComponentType, kQTFileTypePNG,
                                       &grex);

        if (grex) {
            // tell the exporter where to find its source image
            result = GraphicsExportSetInputCGImage(grex, inImageRef);

            if (noErr == result) {
                // tell the exporter where to save the exporter image
                result = GraphicsExportSetOutputDataReference(grex, dataRef,
                                                              dataRefType);

                if (noErr == result) {
                    // write the PNG file
                    result = GraphicsExportDoExport(grex, &sizeWritten);
                }
            }

            // remember to close the component
            CloseComponent(grex);
        }

        // remember to dispose of the data reference handle
        DisposeHandle(dataRef);
    }

    return result;
}
